﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	Private WakeState As PhoneWakeState
	Private tmr As Timer
	Private mCPBValue As Int
	Private mCurrentTime As Long
	Private mGap As Float
End Sub

Sub Service_Create
	tmr.Initialize("tmr", 1000)
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	WakeState.PartialLock
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StartForeground(1, CreateNotification("App avviata"))
	StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerMinute, True)
End Sub

Sub Service_Destroy

End Sub

Public Sub StartTimer(Duration As Float)
	If tmr.Enabled Then tmr.Enabled = False
	mGap = 100 / Duration
	mCurrentTime = Duration * 1000
	tmr.Enabled = True
End Sub

Public Sub StopTimer
	tmr.Enabled = False
	Dim notif As Notification = CreateNotification("Timer fermato")
	notif.Notify(1)
End Sub

Private Sub tmr_Tick
	If mCPBValue >= 100 Then
		StopTimer
		mCPBValue = 0
	Else
		mCPBValue = mCPBValue + mGap
		mCurrentTime = mCurrentTime - 1000
	End If
	CallSubDelayed3(Main, "UpdateCPB", mCPBValue, mCurrentTime)
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_HIGH)
	notification.Icon = "icon"
	notification.SetInfo("Tracking location", Body, Main)
	Return notification
End Sub
